program example_find_sl;
{$mode objfpc}
uses find_SL;

var f:find;
    i,start:longint;
    str:string;


function FindPart(const sub,str:string):integer;
var f:find;
    s:String;
begin
f.FindPart2(sub,str);
f.get_solution(1,result,s);
end;

//----------------------------------------------------------------------

begin
writeln('-------------');
writeln(FindPart('de?g','abcdefghdefgdefgg'));   // 4
writeln('-------------');
for i:=1 to f.FindPart2('de?g','abcdefghdefgdefgg') do    // 4 9 13
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('??:??:??','     01:30:00') do    // 6
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;


for i:=1 to f.FindPart2('de*','abcdefgh') do     // 4
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('*?','abcdefghilmnopqrst') do //1
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('','abcdefghilmnopqrst') do // 0
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de*u','abcdefghiuldemnopuqrst') do // 4 4 12
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de*','abcdefgh') do // 4 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de???????op','abcdefghilmnopqrst') do // 4 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de??op','abcdefghilmnopqrst') do // 0 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de????????op','abcdefghilmnopqrst') do // 0 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de??**op','abcdefghilmnopqrst') do // 4 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de??**??op','abcdefghilmnopqrst') do // 4 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

//----------

for i:=1 to f.FindPart2('de??**op','abcdefghilmnopqrst') do // 4 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de??**o?q','abcdefghilmnopqrst') do // 4 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('q','abcdefghilmnopqrstq') do // 15 19 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('','abcdefghilmnopqrst') do // 0 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('*','abcdefghilmnopqrst') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('*?','abcdefghilmnopqrst') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('de??**??op','abcdefghilmnopqrst') do // 4 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('*?b','abcdefghilmnopqrst') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('?b','abcdefghilmnopqrst') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('b','abcdefghilmnopqrst') do // 2 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

//--------------
for i:=1 to f.FindPart2('b********************************','abcdefghilmnopqrst') do // 2 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('b???????*?????????????????????????','abcdefghilmnopqrst') do // 0 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('??:??:??','12:00:30') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('??:??:??','     01:30:00') do // 6 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('*??*c','abcdefghilmnopqrst') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('?*?:??:??','     01:30:00') do // 1
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('??:*?:??','     01:30:00') do // 6 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('*?*?:??:??','     01:30:00') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('??:??:??','a12:13:14') do // 2 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('ci?cio','cixxciociccio') do // 8 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('?ci?cio','cixxciociccio') do // 7 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('ci','cixxciociccio') do // 1 5 8 11 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('?x?????????','cixxciociccioj') do // 2  3 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('ci*o?o','ci*o?p?o?o') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

for i:=1 to f.FindPart2('*','ci*o?p?o?o') do // 1 ddd
     begin
     f.get_solution(i,start,str);
     writeln(i,' ',start,' ',str);
     end;

end.

